 
DEFINE VARIABLE bodyString          AS LONGCHAR                            NO-UNDO. 
DEFINE VARIABLE APIURI              AS CHARACTER                           NO-UNDO. 
DEFINE VARIABLE sfdcREST            AS SFDC.SFDCREST                       NO-UNDO.
DEFINE VARIABLE jsonResponse        AS LONGCHAR                            NO-UNDO. 
DEFINE VARIABLE httpClient          AS System.Net.Http.HttpClient          NO-UNDO.   
DEFINE VARIABLE httpResponseMessage AS System.Net.Http.HttpResponseMessage NO-UNDO.
DEFINE VARIABLE httpRequestMessage  AS System.Net.Http.HttpRequestMessage  NO-UNDO.   

sfdcREST = NEW SFDC.SFDCREST().
sfdcREST:SFDCPasswordConnect().

APIURI = sfdcREST:ServerURL + "/services/data/v35.0/sobjects/Account/".

MESSAGE APIURI
  VIEW-AS ALERT-BOX.

bodyString = 
  '~{                                           ' +
  '   "Name":"Bob Loblaw~'s Lawblog Pogs",      ' +
  '   "Type":"Legal"                            ' +
  ' ~}'.  

httpRequestMessage = NEW System.Net.Http.HttpRequestMessage().
httpRequestMessage:Method = System.Net.Http.HttpMethod:Post.
httpRequestMessage:RequestUri = NEW System.Uri(APIURI).
httpRequestMessage:Content = NEW System.Net.Http.StringContent(bodyString, System.Text.Encoding:UTF8, "application/json").
httpRequestMessage:Headers:Add ("Authorization", "Bearer " + sfdcREST:AccessToken).
    
httpClient = NEW System.Net.Http.HttpClient().
/* Use SendAsync in a synchronous manner by directly accessing the result */
httpResponseMessage = httpClient:SendAsync(httpRequestMessage):Result. 
jsonResponse = httpResponseMessage:Content:ReadAsStringAsync():RESULT NO-ERROR.

IF  httpResponseMessage:StatusCode:value__ <> 201 THEN  /* created */ 
DO:
  MESSAGE 
    STRING (jsonResponse) SKIP 
    "----------------------------" SKIP 
    httpResponseMessage:StatusCode:value__
    VIEW-AS ALERT-BOX.
  RETURN.
END.

MESSAGE STRING (jsonResponse)
  VIEW-AS ALERT-BOX.
    