{i/SFDCTT.i}
 
DEFINE VARIABLE sfdcID              AS CHARACTER                           NO-UNDO. 
DEFINE VARIABLE htt                 AS HANDLE                              NO-UNDO. 
DEFINE VARIABLE bodyString          AS LONGCHAR                            NO-UNDO. 
DEFINE VARIABLE APIURI              AS CHARACTER                           NO-UNDO. 
DEFINE VARIABLE sfdcREST            AS SFDC.SFDCREST                       NO-UNDO.
DEFINE VARIABLE jsonResponse        AS LONGCHAR                            NO-UNDO. 
DEFINE VARIABLE httpClient          AS System.Net.Http.HttpClient          NO-UNDO.   
DEFINE VARIABLE httpResponseMessage AS System.Net.Http.HttpResponseMessage NO-UNDO.
DEFINE VARIABLE httpRequestMessage  AS System.Net.Http.HttpRequestMessage  NO-UNDO.   

sfdcREST = NEW SFDC.SFDCREST().
sfdcREST:SFDCPasswordConnect().
sfdcId = "0011700000VELp9AAH". 

APIURI = sfdcREST:ServerURL + "/services/data/v35.0/sobjects/Account/" + sfdcId.
bodyString = 
  '~{                                       ' +
  '   "Name":"Bob Loblaw~'s Law Blog Pogs", ' +
  '   "Type":"Manufacturing"                ' +
  '~}'.  

httpRequestMessage = NEW System.Net.Http.HttpRequestMessage().
/*httpRequestMessage:Method = System.Net.Http.HttpMethod:Put. - method not allowed */
httpRequestMessage:Method = NEW System.Net.Http.HttpMethod("PATCH"). /* means update "some" */
httpRequestMessage:RequestUri = NEW System.Uri(APIURI).
httpRequestMessage:Content = NEW System.Net.Http.StringContent(bodyString, System.Text.Encoding:UTF8, "application/json").
httpRequestMessage:Headers:Add ("Authorization", "Bearer " + sfdcREST:AccessToken).
  
httpClient = NEW System.Net.Http.HttpClient().
/* Use SendAsync in a synchronous manner by directly accessing the result */
httpResponseMessage = httpClient:SendAsync(httpRequestMessage):RESULT. 
jsonResponse = httpResponseMessage:Content:ReadAsStringAsync():RESULT NO-ERROR.

IF httpResponseMessage:StatusCode:value__ <> 204 THEN  /* OK but no content returned */ 
DO:
  MESSAGE 
    STRING (jsonResponse) SKIP 
    "Status Code: "httpResponseMessage:StatusCode:value__
    VIEW-AS ALERT-BOX.
  RETURN.
END.
 
MESSAGE httpResponseMessage:StatusCode:value__
VIEW-AS ALERT-BOX.

/* get the account into a TT to show we really updated it */ 
htt = TEMP-TABLE ttCustomer:HANDLE. 

sfdcREST:readRecords (sfdcId, htt).   
FOR EACH ttCustomer:
  MESSAGE ttCustomer.custName SKIP 
    ttCustomer.custType
    VIEW-AS ALERT-BOX.   
END.    
    